

//#include "windows.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/param.h>
#include <values.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include <sys/resource.h>  // To set max file descriptors
#include <dirent.h>

#include <scsi/sg.h>


// would normally be handled by windows
#define TRUE 1
#define FALSE 0


int ProbeGenericDevices(int idx);


int TestLinuxSystem()
{
  system("umask 000; ls -sl /dev/disk/by-id > /tmp/mnttab.sn");

  system("umask 000; ls -sl /dev/sg* > /tmp/dev.sg");
  system("umask 000; ls -sl /dev/sd* > /tmp/dev.sd");


  ProbeGenericDevices(0); // actual work though CreateDeviceEntry commented out for testing purposes
  return 0;
}







int ProbeGenericDevices(int idx) {
  FILE *fp;
  char *cptr, *cptr2;
  //struct stat filestat;
  int ha, pathid, tid, lun, tdev, fd, size;
  char devname[100], tmpstr[100];
  struct sg_scsi_id SID;
  //unsigned char listmem[8192];
  char *listmem;
  tdev = idx;

DebugMessage("ls -1p /dev/sg* | grep -v @ > Temp/disk.list\n");

  system("ls -1p /dev/sg* | grep -v @ > Temp/disk.list\n");



  size = FileSize("Temp/disk.list");

sprintf(tmpstr, "size = %d bytes\n", size);
DebugMessage(tmpstr);

  if(size == 0)
    return 0;
 

  listmem = (char*)malloc(size+1024);
  if(!listmem)
  {
    DebugMessage("Can not allocate listmem\n");
    return 0;
  }


sprintf(tmpstr, "zero memory %p\n", listmem);
DebugMessage(tmpstr);

  memset(&listmem[0], 0, size+9);

DebugMessage("fopen Temp/disk.list\n\n--------------\n");
DebugMessage(listmem);
DebugMessage("--------------\n");

  fp = fopen("Temp/disk.list", "rt");
  if(fp)
  {
DebugMessage("fread\n");
    size = fread(&listmem[0], 1, size, fp);
DebugMessage("fread done\n");
    listmem[size] = 0;
DebugMessage("fclose\n");
    fclose(fp);
DebugMessage("fclose done\n");
  }
  else
  {
    DebugMessage("Can not open Temp/disk.list\n");
    return 0;
  }

DebugMessage("parse listmem\n");

  cptr = listmem;
  while(*cptr != 0 &&  cptr < listmem+size) {
    cptr2 = strchr(cptr, '\n');

    memcpy(devname, cptr, cptr2-cptr);
    devname[cptr2-cptr] = 0;
    sprintf(tmpstr, "%s ...", devname);
    printf("Scanning %-15s", tmpstr);

    cptr = cptr2+1;

    fd = open(devname, O_RDWR | O_NONBLOCK);

    if(fd < 0)
      fd = open(devname, O_RDONLY | O_NONBLOCK);

    if(fd >= 0)  {   // hey, we found one!
#if defined(LINUX)
DebugMessage("ioctl\n");

      if(ioctl(fd, SG_GET_SCSI_ID, &SID)  < 0) {
        ha        = 99;
        pathid    = 99;
        tid       = 99;
        lun       = idx;
      }
      else {
        ha        = SID.host_no;
        pathid    = SID.channel;
        tid       = SID.scsi_id;
        lun       = SID.lun;
      }
#endif
      printf("available! (%d, %d, %d, %d)\n", ha, pathid, tid, lun);
      //CreateDeviceEntry(ha, tid, lun, tdev++, pathid, devname, HBA_SCSI_GENERIC, fd, MAX_BUFFSZ, NULL);
    }
    else {
      Winlib_PrintErrno(errno, 0 , -1, TRUE);
      //printf(" missing\n");
    }

  } // end while()


  free(listmem);

  return tdev;
}